// =================================================================================
//	CDynamicText.h	 								1997 BB's Team inc. All rights reserved
// =================================================================================

#pragma once

#include <LTextEdit.h>
#include <UTextTraits.h>

class CDynamicText : public LTextEdit {
public:
	enum { class_ID = 'DynT' };

	static CDynamicText*		CreateDynamicTextStream ( LStream *inStream );
									CDynamicText ();
									CDynamicText (
										const SPaneInfo	&inPaneInfo,
										const SViewInfo	&inViewInfo,
										Uint16			inTextAttributes,
										ResIDT			inTextTraitsID
									);
									CDynamicText ( const CDynamicText &inOriginal );
									CDynamicText ( LStream *inStream );
	virtual		 				~CDynamicText ()	{}

	virtual void				SetTextTraitsID ( ResIDT inTextTraitsID );
	        void				SetTextTraits ( const TextTraitsRecord &inTextTraits );
	        void				SetTextTraits ( void );
	        void				GetTextTraits ( TextTraitsRecord &outTextTraits ) const;

	        void				SetFont ( const Str255 inFontName );
	        void				GetFont ( Str255 outFontName ) const;

	        void				SetSize ( Int16 inSize );
	        Int16				GetSize () const;

	        void				SetWidth (Int16 inWidth);
	        void				PrepareToPrint (void);
	        void				RevertFromPrint (void);

protected:
	virtual void				FinishCreateSelf();

	TextTraitsRecord			mTextTraits;
	SDimension16				mFrameSize;
};
