// =================================================================================
//	CDocument.h										1997 BB's Team inc. All rights reserved
// =================================================================================

#pragma once

#include "CPreferences.h"
#include "CDynamicText.h"
#include "CGWorldPane.h"
#include "GreyGWorld.h"

#include "FontLight.h"
#include "ImageLight.h"
#include "GenText.h"

#include <LSingleDoc.h>
#include <LListener.h>
#include <LPlaceHolder.h>
#include <UTextTraits.h>

class CPict2AsciiApp; 	// MJS 97-05-29

class CDocument : public LSingleDoc,
                  public LListener {

friend class CPict2AsciiApp; 	// MJS 97-05-29

public:
							CDocument(
								LCommander *inSuper,
								FSSpec *inFileSpec,
								CPreferences *,
								Boolean inVisible = true); 	// MJS 97-05-29

	virtual 				~CDocument();

	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();

	virtual void		AttemptClose( Boolean inRecordIt );	// MJS 97-05-29

	virtual void		GetAEProperty(
								DescType		inProperty,
								const AEDesc	&inRequestedType,
								AEDesc			&outPropertyDesc) const;	// MJS 97-05-29

protected:
	
	CDynamicText		*mDynamicText;
	CGWorldPane			*mShowPane;
	Int32					mRatio;

	TextTraitsRecord	mTextTraits;

	CPreferences		*mPreferences;

	GreyGWorld			mGreyPict;
	FontLight			mFontLight;
	ImageLight			mImageLight;
	GenText				mGenText;

	Boolean				mVisible;	// MJS 97-05-29

	void					SetupControls (void);
	void					SetStatus (ConstStringPtr="\p");
	void					SetStatus (ResIDT, Int16);
	void					SetTextStr (ConstStringPtr);
	void					SetTextStr (ResIDT, Int16);

	OSErr					ReadPictFile (void);
	void					SetName (Str63 inName);
	Boolean				OpenFile( FSSpec &inFileSpec);
	virtual void		Compute (void);
	Boolean				TellOverflow (void);

	void					AdjustSizeMenuForFont (Int16 inFontNumber);
	Boolean				ObeyCommand (CommandT inCommand,	void *ioParam);
	Boolean				UpdateZoom (void);
	virtual Boolean	HandleKeyPress (const EventRecord &inKeyEvent);
	virtual void		ListenToMessage (MessageT inMessage, void *ioParam);
	virtual void		FindCommandStatus( CommandT inCommand,
								Boolean &outEnabled, Boolean &outUsesMark,
								Char16 &outMark, Str255 outName );

	void					ClearInfo();
	void					UpdateInfo();
	void					UpdatePagesNumber(void);

	virtual void		DoPrint (void);
	Int16					DoMaybePrint (Boolean doIt);
	void					SetPrintFrameSize (LPlaceHolder*);
	void					SetupPage (void);
};
