// =================================================================================
//	CPreferences.h									1997 BB's Team inc. All rights reserved
// =================================================================================

#pragma once

#include "PLConstants.h"

#include <LString.h>
#include <UTextTraits.h>
#include <LPreferencesFile.h>

typedef struct Prefs {
	Boolean					sScreen;
	Boolean					s7Bits;
	Boolean					sContrast;

	Boolean					sConfirmPrinting;
	Boolean					sMonoSpace;
	Boolean					sBeep32k;
	Str255					sAlphabet;
	TextTraitsRecord		sTextTraits;
} Prefs;


class CPreferences  {

public:
								CPreferences  (void);
	virtual 					~CPreferences ();

	void						DoDialog (LStr255 allowed, const Str255 displayFont = "\p");
	Boolean					IsOk (); 
	void						FinishCreate (void);

	// accessors
	void						GetTextTraits (TextTraitsRecord&) const;
	Boolean					GetScreen() const				{	return mPrefs.sScreen;				}
	Boolean					Get7Bits() const				{	return mPrefs.s7Bits;				}
	Boolean					GetContrast() const			{	return mPrefs.sContrast;			}
	Boolean					GetMonoSpace() const			{	return mPrefs.sMonoSpace;			}
	LStr255					GetAllowed() const			{	return mPrefs.sAlphabet;			}
	Boolean					GetBeep32k() const			{	return mPrefs.sBeep32k;				}
	Boolean					GetPrintConfirm() const		{	return mPrefs.sConfirmPrinting;	}

	// settors ?
	void						SetTextTraits (const TextTraitsRecord	&);
	void						SetBeep32k (Boolean u)		{	mPrefs.sBeep32k = u;				}
	void						SetScreen (Boolean u)		{	mPrefs.sScreen = u;				}
	void						Set7Bits (Boolean u)			{	mPrefs.s7Bits = u;				}
	void						SetContrast (Boolean u)		{	mPrefs.sContrast = u;			}

protected:

	LPreferencesFile		mFile;
	Prefs						mPrefs;

	void						AllowAll (Str255 &allow);
	void						ReadPrefs	(void);
	void						WritePrefs	(void);
	

};
